



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>webpack学习笔记 (二) html-webpack-plugin使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">webpack学习笔记 (二) html-webpack-plugin使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 07:51:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这个插件的两个作用：</p>
<ul><li><p>为html文件中引入的外部资源如<code>script</code>、<code>link</code>动态添加每次compile后的hash，防止引用缓存的外部文件问题</p></li>
<li><p>可以生成创建html入口文件，比如单页面可以生成一个html文件入口，配置<strong>N</strong>个<code>html-webpack-plugin</code>可以生成<strong>N</strong>个页面入口</p></li></ul>
<p>安装使用如下：</p>
<p>一、首先安装html-webpack-plugin插件</p>
<p>在cmd中打开项目，输入cnpm install&nbsp;html-webpack-plugin；</p>
<p>二、在webpack-config.js的plugins里面添加 信息，如下图</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/891395/201705/891395-20170507151316789-768941679.png" /></p>
<p>然后在cmd中输入，webpack，即可以在项目文件夹下自动生成index.html。如果报错，则表示，未安装html-webpack-plugin插件。</p>
<p>注：不配置任何选项的<code>html-webpack-plugin</code>插件，他会默认将webpack中的<code>entry</code>配置所有入口thunk和<code>extract-text-webpack-plugin</code>抽取的css样式都插入到文件指定的位置。</p>
<p>三、多页面配置</p>
<p>对于生成多页面的情况，在plugins配置多个plugin即可</p>
<div>
<div>
<pre class="prettyprint linenums"> plugins:[<br />
         new webpack.BannerPlugin('测试webpack搭建   '),<br />
         new HtmlWebpackPlugin(),<br />
         new HtmlWebpackPlugin({<br />
           title:'测试webpack',<br />
           template: 'src/template/index.html', // 源模板文件<br />
           filename: './index1.html', // 输出文件【注意：这里的根路径是module.exports.output.path】<br />
           showErrors: true,<br />
           inject: 'body',<br />
           chunks: ["index"],<br />
           favicon:"./src/fav.ico",<br />
           hash:true,<br />
           minify:{<br />
                 caseSensitive: false, //是否大小写敏感<br />
                 removeComments:true, // 去除注释<br />
                 removeEmptyAttributes:true, // 去除空属性<br />
                 collapseWhitespace: true //是否去除空格<br />
             }<br />
       }),<br />
         new HtmlWebpackPlugin({<br />
           title:'测试webpack',<br />
           template: 'src/template/index.html', // 源模板文件<br />
           filename: './index2.html', // 输出文件【注意：这里的根路径是module.exports.output.path】<br />
           showErrors: true,<br />
           inject: 'body'<br />
       })<br />
     ]</pre>
</div>
<p>多页面配置</p></div>
<p>四、使用template模板页面</p>
<p>增加模板页面</p>
<div>
<div>
<pre class="prettyprint linenums"> &lt;!DOCTYPE html&gt;<br />
 &lt;html&gt;<br />
 &lt;head&gt;<br />
     &lt;meta charset="utf-8"&gt;<br />
     &lt;title&gt;&lt;%= htmlWebpackPlugin.options.title %&gt;&lt;/title&gt;<br />
     &lt;% for (var css in htmlWebpackPlugin.files.css) { %&gt;<br />
     &lt;link href="&lt;%=htmlWebpackPlugin.files.css[css] %&gt;" rel="stylesheet"&gt;<br />
     &lt;% } %&gt;<br />
 &lt;/head&gt;<br />
 &lt;body&gt;<br />
 &lt;!-- 测试 --&gt;<br />
 &lt;div id="app" style=""&gt;&lt;/div&gt;<br />
 &lt;/body&gt;<br />
 &lt;script type="text/babel"&gt;<br />
 &lt;/script&gt;<br />
 &lt;/html&gt;</pre>
</div>
<p>模板页面</p></div>
<p>在配置中配置模板页面</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/891395/201705/891395-20170507175757117-1093558206.png" /></p>
<p>五、自定义增加的js文件</p>
<p>在配置文件中，chunks选项添加对应的内容即可。</p>
<p>对应的内容为entry中的属性。具体如下图</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/891395/201705/891395-20170507180112836-693133549.png" /></p>
<p>六、生成页面压缩</p>
<p>配置minify配置项，常用的几个配置见上图</p>
<p>七、其他配置项解释如下</p>
<ul><li><p>title: 生成的HTML模板的title，如果模板中有设置title的名字，则会忽略这里的设置</p></li>
<li><p>filename: 生成的模板文件的名字</p></li>
<li><p><strong>关于filename补充两点：</strong></p>
<blockquote><p>1、filename配置的html文件目录是相对于webpackConfig.output.path路径而言的，不是相对于当前项目目录结构的。<br />2、指定生成的html文件内容中的<code>link</code>和<code>script</code>路径是相对于生成目录下的，写路径的时候请写生成目录下的相对路径。</p></blockquote></li>
<li><p>template: 模板来源文件</p></li>
<li><p><strong>关于template补充几点：</strong></p>
<blockquote><p>1、template配置项在html文件使用<code>file-loader</code>时，其所指定的位置找不到，导致生成的html文件内容不是期望的内容。<br />2、为template指定的模板文件没有指定<strong>任何loader的话</strong>，默认使用<code>ejs-loader</code>。如<code>template: './index.html'</code>，若没有为<code>.html</code>指定任何loader就使用<code>ejs-loader</code></p></blockquote></li>
<li><p>inject: 引入模块的注入位置；取值有true/false/body/head；true | 'head' | 'body' | false &nbsp;,注入所有的资源到特定的 template 或者 templateContent 中，如果设置为 true 或者 body，所有的 javascript 资源将被放置到 body 元素的底部，'head' 将放置到 head 元素中。</p></li>
<li><strong>true或者body</strong>：所有<strong>JavaScript</strong>资源插入到body元素的底部<br />2、<strong>head</strong>: 所有<strong>JavaScript</strong>资源插入到head元素中<br />3、<strong>false</strong>： 所有静态资源css和JavaScript都不会注入到模板文件中</li>
<li><p>favicon: 指定页面图标；</p></li>
<li><p>minify: {} | false , 传递 html-minifier 选项给 minify 输出。是<code>html-webpack-plugin</code>中集成的&nbsp;<code>html-minifier</code>&nbsp;，生成模板文件压缩配置，有很多配置项，可以查看<a href="https://github.com/kangax/html-minifier#options-quick-reference" rel="external nofollow noreferrer">详细文档</a></p>
<pre class="prettyprint linenums"><code>   caseSensitive: false, //是否大小写敏感<br />
   collapseBooleanAttributes: true, //是否简写boolean格式的属性如：disabled="disabled" 简写为disabled<br />
   collapseWhitespace: true //是否去除空格<br />
</code></pre></li>
<li><p>hash: 是否生成hash添加在引入文件地址的末尾，类似于我们常用的时间戳，比如最终引入是：<code>&lt;script type="text/javascript" src="bundle.049424f7d7ea5fa50656.js?049424f7d7ea5fa50656"&gt;&lt;/script&gt;</code>。这个可以避免缓存带来的麻烦</p></li>
<li><p>cache: 是否需要缓存，如果填写true，则文件只有在改变时才会重新生成</p></li>
<li><p>showErrors: 是否将错误信息写在页面里，默认true，出现错误信息则会包裹在一个<code>pre</code>标签内添加到页面上</p></li>
<li><p>chunks: 引入的模块，这里指定的是entry中设置多个js时，在这里指定引入的js，如果不设置则默认全部引入</p></li>
<li><p>chunksSortMode: 引入模块的排序方式，支持的值：'none' | 'default' | {function}-default:'auto'</p></li>
<li><p>excludeChunks: 排除的模块</p></li>
<li><p>xhtml: 生成的模板文档中标签是否自动关闭，针对xhtml的语法，会要求标签都关闭，默认false</p></li></ul>
<p>八、插件事件（<a href="http://www.cnblogs.com/wonyun/p/6030090.html" rel="external nofollow noreferrer">引用位置</a>）</p>
<p>不知道你发现没有，html-webpack-plugin插件在插入静态资源时存在一些问题：</p>
<ul><li><strong>在插入js资源只能插入head或者body元素中，不能一些插入head中，另一些插入body中</strong></li>
<li><strong>不支持在html中文件内联</strong>*，例如在文件的某个地方用<code>&lt;script src="xxx.js?__inline"&gt;&lt;/script&gt;</code>来内联外部脚本</li></ul>
<p>为此，有人专门给插件作者提问了<a href="https://github.com/ampedandwired/html-webpack-plugin/issues/157" rel="external nofollow noreferrer">这个问题</a>；对此插件作者提供了插件事件，允许<strong>其他插件</strong>来改变html文件内容。具体的事件如下：</p>
<p>Async（异步事件）:</p>
<pre class="prettyprint linenums"><code>    * html-webpack-plugin-before-html-generation<br />
    * html-webpack-plugin-before-html-processing<br />
    * html-webpack-plugin-alter-asset-tags<br />
    * html-webpack-plugin-after-html-processing<br />
    * html-webpack-plugin-after-emit</code></pre>
<p>Sync（同步事件）:</p>
<pre class="prettyprint linenums"><code>    * html-webpack-plugin-alter-chunks</code></pre>
<p>这些事件是提供给其他插件使用的，用于改变html的内容。因此，要用这些事件需要提供一个webpack插件。例如下面定义的<code>MyPlugin</code>插件。</p>
<div>
<pre class="prettyprint linenums"><code><br />
function MyPlugin(options) {<br />
  // Configure your plugin with options...<br />
}

MyPlugin.prototype.apply = function(compiler) {<br />
  // ...<br />
  compiler.plugin('compilation', function(compilation) {<br />
    console.log('The compiler is starting a new compilation...');

    compilation.plugin('html-webpack-plugin-before-html-processing', function(htmlPluginData, callback) {<br />
      htmlPluginData.html += 'The magic footer';<br />
      callback(null, htmlPluginData);<br />
    });<br />
  });

};

module.exports = MyPlugin;</code></pre>
</div>
<p>然后，在<code>webpack.config.js</code>文件中配置<code>Myplugin</code>信息：</p>
<div>
<pre class="prettyprint linenums"><code>plugins: [<br />
  new MyPlugin({options: ''})<br />
]</code></pre>
</div>
<p>注：一个比较全的配置</p>
<div>
<div>
<pre class="prettyprint linenums"> var webpack=require('webpack');<br />
 var HtmlWebpackPlugin = require('html-webpack-plugin');

 module.exports = {<br />
     devtool: 'eval-source-map', // 还不知有什么用<br />
     entry: {<br />
             index:"./src/js/runoob1.js",<br />
             main:"./src/js/runoob1.js"<br />
         },<br />
     output: {<br />
         path: __dirname+"/build/web/",    //通过HtmlWebpackPlugin插件生成的html文件存放在这个目录下面<br />
         filename: "../js/[name].js" //编译生成的js文件存放到根目录下面的js目录下面,如果js目录不存在则自动创建，相对于path<br />
     },<br />
     module: {<br />
         loaders: [<br />
             { test: /\.css$/, loader: "style-loader!css-loader" }<br />
         ]<br />
     },<br />
     plugins:[<br />
         new webpack.BannerPlugin('测试webpack搭建           '),<br />
         new HtmlWebpackPlugin(),<br />
         new HtmlWebpackPlugin({<br />
           title:'测试webpack',<br />
           template: 'src/template/index.html', // 源模板文件<br />
           filename: './index1.html', // 输出文件【注意：这里的根路径是module.exports.output.path】<br />
           showErrors: true,<br />
           inject: 'body',<br />
           chunks: ["index"],<br />
           favicon:"./src/fav.ico",<br />
           hash:true,<br />
           minify:{<br />
                 caseSensitive: false, //是否大小写敏感<br />
                 removeComments:true, // 去除注释<br />
                 removeEmptyAttributes:true, // 去除空属性<br />
                 collapseWhitespace: true //是否去除空格<br />
             }<br />
       }),<br />
         new HtmlWebpackPlugin({<br />
           title:'测试webpack',<br />
           template: 'src/template/index.html', // 源模板文件<br />
           filename: './index2.html', // 输出文件【注意：这里的根路径是module.exports.output.path】<br />
           showErrors: true,<br />
           inject: 'body'<br />
       })<br />
     ]<br />
 };</pre>
</div>
<p>完整配置</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnlywg9.html">wc</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2v4gx8.html">&lbrack;转载&rsqb;将别人的项目或JAVA文件导入到自己的Eclipse中时，常常会出现JAVA文件的中文注释变成乱码的情况，解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m53v2q.html">关于&period;net 中Clipboard&period;GetDataObject&lpar;&rpar; 之后读出数据读出的数据都是相同的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zzmr38.html">从RTSP协议SDP数据中获得二进制的SPS、PPS</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnp02g8.html">并查集&lpar;Disjoint Set&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxne5wz8.html">IOS开发之上传APP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zddv69.html">取A表数据，关联B表任意一条数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vlx3o8.html">Android应用换肤总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1714v9.html">OS X Lion版 如果我忘记了我的账户密码 我该怎么办&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ykgjg8.html">protobuf java基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zv3wk9.html">C&num; 使用 GDI&plus; 实现添加中心旋转&lpar;任意角度&rpar;的文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkgk7v8.html">bzoj1911&lbrack;Apio2010&rsqb;特别行动队 斜率优化dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrlld8.html">分享一下  常用的转换方法（例如：数字转金钱，文本与html互转等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjxomx8.html">【Android Studio安装部署系列】三十一、从Android studio3&period;0&period;0升级到Android studio3&period;0&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4ee08.html">select标签 禁止选择但又能通过序列化form表单传值到后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zk2lk9.html">基于 EntityFramework、Autofac 的 UnitOfWork 框架（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q253e3wq.html">最详细的 paypal 支付接口开发--Java版</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyjn0q.html">Flask系列学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rxpw48.html">ls --help 常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lrgwq.html">hihoCoder week6  01背包</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1gpejq.html">python处理日志文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp36k79.html">oo第二次博客总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meo4g0q.html">&num;WEB安全基础 &colon; HTTP协议 &vert; 0x14 HTTP的详细安全问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjro0g8.html">Excel控制AutoCad进行坐标标注</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjr7l28.html">mysql索引类型&lpar;按存储结构划分&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zp4d19.html">安卓自定义TextView实现自动滚动</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zexv39.html">nginx &plus; keepalived 主从模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/950552m8.html">MTK&lpar;android init&period;rc&rpar; 写一个开机启动的服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj005j9.html">Flutter 输入控件TextField设置内容并保持光标&lpar;cursor&rpar;在末尾</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj11wl9.html">使用nginx代理kibana并配置登录验证</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
